/**
 *
 */
(function ($, Drupal, drupalSettings) {

  'use strict';

  Drupal.behaviors.xhprof = {
    attach: function (context) {
      var switched = false;
      var updateTables = function () {
        if (($(window).width() < 1800) && !switched) {
          switched = true;
          $('table.responsive').each(function (i, element) {
            splitTable($(element));
          });
          return true;
        }
        else if (switched && ($(window).width() > 1800)) {
          switched = false;
          $('table.responsive').each(function (i, element) {
            unsplitTable($(element));
          });
        }
      };
      $(window).on('load', updateTables);
      $(window).bind('resize', updateTables);
      function splitTable(original) {
        original.wrap('<div class="table-wrapper" />');
        var copy = original.clone();
        copy.find('td:not(:first-child), th:not(:first-child)').css('display', 'none');
        copy.removeClass('responsive');
        original.closest('.table-wrapper').append(copy);
        copy.wrap('<div class="pinned" />');
        original.wrap('<div class="scrollable" />');
      }

      function unsplitTable(original) {
        original.closest('.table-wrapper').find('.pinned').remove();
        original.unwrap();
        original.unwrap();
      }
    }
  };

})(jQuery, Drupal, drupalSettings);
